<?php namespace App\Models;

use App\Entities\DocumentoAnexo\DocumentoAnexo;
use App\Utils\DateUtils;

class DocumentoAnexoModel extends ModelEntity
{
    protected $table = 'documentos_anexados';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'url',
        'id_cliente',
        'id_pet',
        'descricao',
        'criado_em',
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;
    protected $createdField  = 'criado_em';
    protected $updatedField  = 'alterado_em';

    public function registerDocumentoAnexo (DocumentoAnexo $arquivo) : void {

        $data = $arquivo->toArray(true);
        $id_procedimento = $this->insert($data);
        $arquivo->setId($id_procedimento);
    }

    public function updateDocumentoAnexoByID (int $id_procedimento, DocumentoAnexo $arquivo) : bool {
        $data = $arquivo->toArray(true);
        $data['alterado_em'] = DateUtils::now();
        $binds = ['id_procedimento' => $id_procedimento];
        $sets = $this->generateUpdateSets($data, $binds);
        $sql = "UPDATE procedimento $sets WHERE procedimento.id = :id_procedimento:";
        log_message('error', $sql);
        log_message('error', json_encode($data));
        log_message('error', json_encode($binds));
        $query = $this->db->query($sql, $binds);
        return $query->connID->affected_rows === 1;
    }
}
